// Generated by CoffeeScript 1.12.7
(function() {
  var MyAdvError, MyError, defineError, e, f0, f1, f2, headStackTrace, indent, log, showInfo;

  indent = function(text) {
    return text.split('\n').map(function(l) {
      return '  ' + l;
    }).join('\n');
  };


  /*
   * Case 1: showInfo : (fields : List String) -> ((info : Object) -> String)
   * Case 2: showInfo : (msgMaker : (info : Object) -> String) -> ((info : Object) -> String)
   */

  showInfo = function(msgMaker) {
    if (typeof msgMaker === 'function') {
      return msgMaker;
    } else if (msgMaker instanceof Array) {
      return function(info) {
        return '\n' + msgMaker.map(function(k) {
          var v;
          v = info[k];
          return "  [" + k + "]: " + (JSON.stringify(info[k]));
        }).join('\n');
      };
    } else {
      return function(s) {
        if (typeof s === 'object') {
          return JSON.stringify(s);
        } else {
          return s;
        }
      };
    }
  };

  headStackTrace = function(e) {
    var i, j, s;
    s = e.stack;
    i = s.indexOf('\n    at ');
    j = s.indexOf('\n', i + 8);
    return s.slice(0, +j + 1 || 9e9);
  };


  /*
   * Usage 1: defineError(errorName : String, fields : List String)
   * Usage 2: defineError(errorName : String, msgMaker : (info : Object) -> String)
   */

  defineError = function(errorName, msgMaker) {
    var msg;
    msg = showInfo(msgMaker);
    
	function CustomError(info, cause) {
		if (Error.captureStackTrace) {
			Error.captureStackTrace(this, CustomError);
		} else {
			Object.defineProperty(this, 'stack', {
				enumerable: false,
				get: function(){return (new Error(this.name + ": " + this.message)).stack}
			});
		}

		Object.defineProperties(this, {
			'name': {enumerable: true, writable: false, value: errorName},
			'message': {enumerable: false, get: function(){ //the parts with stacktrace is not enumerable
				r = msg(info) + (cause == null ? '' : '\n\n' + indent('Caused By: ' + headStackTrace(cause)))
				return r
			}},
			'info': {enumerable: true, writable: false, value: info},
			'cause': {enumerable: false, writable: false, value: cause},
		});
	}
	Object.setPrototypeOf(CustomError.prototype, Error.prototype);
	;
    return CustomError;
  };

  module.exports = defineError;

  if (module.parent === null) {
    log = require('coffee-mate').log;
    MyError = defineError('MyError', function() {
      return "my error occurs";
    });
    try {
      throw new MyError();
    } catch (error) {
      e = error;
      log(function() {
        return e;
      });
      log(function() {
        return e.name;
      });
      log(function() {
        return e.constructor.name;
      });
      log(function() {
        return e.constructor.name === e.name;
      });
      log(function() {
        return e.message === "my error occurs";
      });
      log(function() {
        return typeof e === "object";
      });
      log(function() {
        return typeof MyError === "function";
      });
      log(function() {
        return Object.getPrototypeOf(e) === Error.prototype;
      });
      log(function() {
        return Object.getPrototypeOf(e) === MyError.prototype;
      });
      log(function() {
        return e instanceof Error;
      });
      log(function() {
        return e instanceof MyError;
      });
      log(function() {
        return typeof e.toString === 'function' && e.toString().indexOf(e.name) >= 0;
      });
      log(function() {
        return e.stack.indexOf(e.name) >= 0;
      });
      log(function() {
        return e.stack.indexOf(e.message) >= 0;
      });
    }
    MyAdvError = defineError('MyAdvError', ['f', 'msg']);
    f0 = function() {
      throw new Error('the inner custom error');
    };
    f1 = function() {
      try {
        return f0();
      } catch (error) {
        e = error;
        throw new MyAdvError({
          f: 'f1',
          msg: 'the medium custom error'
        }, e);
      }
    };
    f2 = function() {
      try {
        return f1();
      } catch (error) {
        e = error;
        throw new MyAdvError({
          f: 'f2',
          msg: 'the outer custom error'
        }, e);
      }
    };
    f2();
  }

}).call(this);
